﻿using System;
using System.Reflection;
using System.Linq;
using System.Xml;

namespace GSpreadCOM.Domain
{
	static class Config
	{
		public const string APP_NAME = "GSpreadCOM";

		private static XmlDocument doc;
		private static XmlElement root;

		public static void Initialize()
		{
			AppDomain.CurrentDomain.AssemblyResolve += new ResolveEventHandler(CurrentDomain_AssemblyResolve);

			doc = new XmlDocument();

			try
			{
				doc.Load(string.Concat(APP_NAME, ".config"));
			}
			catch
			{
			}

			root = doc.SelectSingleNode("/config") as XmlElement;
		}

		private static Assembly CurrentDomain_AssemblyResolve(object sender, ResolveEventArgs args)
		{
			return Assembly.LoadFrom(new AssemblyName(args.Name).Name + ".dll");
		}

		public static string GetText(string xpath)
		{
			XmlNode node = root.SelectSingleNode(xpath);
			return node != null ? node.InnerText : "";
		}

		public static string GetAttribute(string xpath, string attr)
		{
			XmlElement el = root.SelectSingleNode(xpath) as XmlElement;
			return el != null ? el.GetAttribute(attr) : "";
		}

		public static string[] GetList(string xpath)
		{
			return root.SelectNodes(xpath).Cast<XmlElement>().Select(e => e.InnerText).ToArray();
		}
	}
}