﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace GSpreadCOM.Domain
{
	internal class ExcelColor
	{
		public const int FAULT_VALUE = -1;
		public const string FAULT_HTML_VALUE = "#ff00ff";

		public string Name { get; private set; }
		public string HtmlValue { get; private set; }
		public Color Value { get; private set; }
		public int IntValue { get; private set; }

		public ExcelColor(string name, string htmlValue)
		{
			Initialize(name, htmlValue);
		}

		public ExcelColor(dynamic value)
		{
			string htmlValue = FAULT_HTML_VALUE;
			if (value is string)
			{
				ExcelColor xlColor = ExcelColorPalette.GetByName(value);
				if (xlColor != null)
				{
					htmlValue = xlColor.HtmlValue;
				}
				else if ((value as string).StartsWith("#"))
				{
					htmlValue = value;
				}
			}
			else if (value is int)
			{
				htmlValue = ExcelColorPalette.IntToHtmlColor(value);
			}
			Initialize("", htmlValue);
		}

		protected void Initialize(string name, string htmlValue)
		{
			Name = name;
			HtmlValue = htmlValue;
			Value = ColorTranslator.FromHtml(htmlValue);
			IntValue = ExcelColorPalette.HtmlColorToInt(htmlValue);
		}
	}
}
